// ************** Generate the tree diagram	 *****************
var margin = {top: 20, right: 120, bottom: 20, left: 120},
	width = 900 - margin.right - margin.left,
	height = 900 - margin.top - margin.bottom;
	
var i = 0,   
	duration = 1100,
	root;

var svg = d3.select("body")
  .append("svg")
	.attr("width", width + margin.right + margin.left)
	.attr("height", height + margin.top + margin.bottom)
  .append("g")
	.attr("transform", "translate(" + margin.left + "," + margin.top + ")");

var diagonal = d3.svg.diagonal()
	.projection(function(d) { return [d.y, d.x]; });

var tree = d3.layout.tree()
	.size([height, width]);

// load the external data
var treeData;//= d3.json("qn_tree.json");
d3.json("qn_tree.json", function(treeData) {

//console.log(treeData);
root=treeData.children[0];
  

//root= d3.hierarchy(treeData, function(d) { return d.children; });
//console.log(root[0]);
  //d3.hierarchy(treeData, function(d) { return d.children; });
root.x0 = height / 2;
root.y0 = 0;
// Collapse after the second level
//root.children.forEach(function collapse(d) {
  //if(d.children) {
   // d._children = d.children
    //d._children.forEach(collapse)
    //d.children = null
  //}
//});
   root.children.forEach(collapse);
   update(root);

  d3.select(self.frameElement).style("height", "900px");
});
// Collapse the node and all it's children

function update(source) {

  // Assigns the x and y position for the nodes
  //var treeData = tree(root);
   console.log("source=>",source);
  // Compute the new tree layout.
   var nodes = tree.nodes(source).reverse();
	 var links = tree.links(nodes);
  
 // console.log("Node =>"+JSON.stringify(nodes));
  // Compute the new tree layout.
 // var nodes = treeData.descendants(),
  //    links = treeData.descendants().slice(1);

  // Normalize for fixed-depth.
  nodes.forEach(function(d) { d.y = d.depth * 120; });

  // Update the nodes…
  var node = svg.selectAll("g.node")
	  .data(nodes, function(d) { return d.id || (d.id = ++i); });

  // Enter any new nodes at the parent's previous position.
  var nodeEnter = node.enter().append("g")
	  .attr("class", "node")
	  .attr("transform", function(d) { 
      //console.log("node:"+d.name+":"+d.type);
      return "translate(" + source.y0 + "," + source.x0 + ")"; 
        })
	  .on("click", click);
  


  nodeEnter.append("circle")
  .attr("r", 1e-6)
   // .attr("r", 25)
  .style("fill", function(d) {
           return d._children ? "lightsteelblue" : "#fff"; });

  
  // nodeEnter.append("image")
  //     .attr("xlink:href", function(d) { return d.icon; })
  //     .attr("x", "-12px")
  //     .attr("y", "-12px")
  //     .attr("width", "50px")
  //     .attr("height", "50px");

  nodeEnter.append("text")
	  .attr("x", function(d) { return d.children || d._children ? -12 : 12; })
	  .attr("dy", ".35em")
	  .attr("text-anchor", function(d) { return d.children || d._children ? "end" : "start";    })
	  .text(function(d) { return d.name; })
	  .style("fill-opacity", 1e-6);

  // Transition nodes to their new position.
  var nodeUpdate = node.transition()
	  .duration(duration)
	  .attr("transform", function(d) { return "translate(" + d.y + "," + d.x + ")"; });

  nodeUpdate.select("circle")
	  .attr("r", 8)
	  .style("fill", function(d) { 
      //console.log("update return type:"+d.type);
    
      return d._children ? "lightsteelblue" : "#fff"; 
  
    }).attr("class", function(d){
              if(d.type){
            console.log("enter return type:"+d.type);
            return d.type;
          }else{
         //  return d._children ? "lightsteelblue" : "#fff";
            return "";
          }});

  nodeUpdate.select("text")
	  .style("fill-opacity", 1);

  // Transition exiting nodes to the parent's new position.
  var nodeExit = node.exit().transition()
	  .duration(duration)
	  .attr("transform", function(d) {
      
      return "translate(" + source.y + "," + source.x + ")"; })
	  .remove();

  nodeExit.select("circle")
	  .attr("r", 1e-6);

  nodeExit.select("text")
	  .style("fill-opacity", 1e-6);

  // Update the links…
  var link = svg.selectAll("path.link")
	  .data(links, function(d) { return d.target.id; });

  // Enter any new links at the parent's previous position.
  link.enter().insert("path", "g")
	  .attr("class", "link")
	  .attr("d", function(d) {
		var o = {x: source.x0, y: source.y0};
		return diagonal({source: o, target: o});
	  });

  // Transition links to their new position.
  link.transition()
	  .duration(duration)
	  .attr("d", diagonal);

  // Transition exiting nodes to the parent's new position.
  link.exit().transition()
	  .duration(duration)
	  .attr("d", function(d) {
		var o = {x: source.x, y: source.y};
		return diagonal({source: o, target: o});
	  })
	  .remove();

  // Stash the old positions for transition.
  nodes.forEach(function(d) {
	d.x0 = d.x;
	d.y0 = d.y;
  });
  
 
}
 function diagonalnew(s, d) {

    path = `M ${s.y} ${s.x}
            C ${(s.y + d.y) / 2} ${s.x},
              ${(s.y + d.y) / 2} ${d.x},
              ${d.y} ${d.x}`

    return path
  }
function collapse(d) {
  if(d.children) {
    d._children = d.children
    d._children.forEach(collapse)
    d.children = null
  }
}
// Toggle children on click.
function click(d) {
  console.log("parent depth:",d.parent);
  console.log("children",d.children);
  console.log("_children",d._children);
  
  if (d.children) {
    //todo after click collpase
    d._children = d.children;
    d.children = null;
       if(d.parent){
           update(d.parent);}

  } else {
    d.children = d._children;
    if(!d.parent)
    {d.parent=d.children[0].parent}
    d._children = null;
    if (d.children && d.parent) {
      update(d.parent);
    }
     
  }